/* Ejemplo simple de uso de GglScreen */
#include "png2.h"
#include <ggl/ggl.h>
#include <stdlib.h>

#include <signal.h> // FIXME : Doesn't neccesary

void nohang(int i)
{
  // This function causes to never get hang because you can exit cleanly 
  // with a simple CTRL+C
  exit(0);
}

int DEPTH=GGL_16BIT;

int NUM_SPRITES=2;

#define FPS 32

GglScreen *screen;
GglSprite **sprite; /* an sprite array */
GglSprite *background;
GglKeyDev *keyboard;      /* The keyboard device */
GglMouseDev *mouse;      /* The mouse device */
GglJoyDev *joystick;      /* The joystick device */

int *sense; /* sense of movement array */
char *collission; /* Indicates whether a collision was detected in the previous frame */
#define SPEED 3


#define FRAMES 12

GglAnim *load_anim()
{
    GglVisual *body=NULL;
    char *fname=(char *)malloc(1024);
    GglAnim   *anim=ggl_anim_new();
    char *palette;
    int palette_size;
    int tx,ty;
    int i;
    for (i=1;i<=FRAMES;i++)
    {
	GglFrame *frame;
	printf(".");fflush(stdout);
	sprintf(fname,"m%i.png",i);
	printf("abriendo [%s]\n",fname);
	//gifinfo(fname,&tx,&ty,palette);
	get_png_info(fname,&tx,&ty,&palette,&palette_size);
	body=ggl_visual_new_target("memory");
	ggl_visual_set_mode(body,tx,ty,tx,ty,GGL_8BIT,1);

	ggl_visual_set_palette(body,ggl_palette_new_from_array(0,palette_size,palette));
	get_png_data(fname,ggl_visual_get_write_pointer(body));

	ggl_visual_change_depth(body,DEPTH);

	frame=ggl_frame_new(body);
	ggl_frame_set_transparent(frame, ggl_color_new(body,0xFFFF,0xFFFF,0xFFFF));
	ggl_anim_append(anim,frame);
    }
    free(fname);
    return anim;
}

void load_sprite()
{
    GglAnim *anim;
    printf("Loading frames ");fflush(stdout);
    anim=load_anim();
    printf("\n");
    sprite[0]=ggl_sprite_new();
    ggl_sprite_append(sprite[0],anim);
}

#define LEFT GIIK_Left
#define RIGHT GIIK_Right
#define ESC GIIUC_Escape

void update_button_sprite1(GglObserver *observer, GglDeviceType type,int device_number,int button,int value)
{
    if (button==LEFT) sense[0]=-1;
    else if (button==RIGHT) sense[0]=1;
    else if (button==ESC) ggl_exit();
    else
        printf("Unknown: <%i>\n",button);
}



void sprite_control(GglScreen *screen)
{
    int i;
    int j;
    for (i=0;i<NUM_SPRITES;i++)
    {
        float x,y;
	ggl_sprite_position(sprite[i],&x,&y);
	if (x >= 640-128) {sense[i]=-1;collission[i]=0;}
	if (x <= SPEED) {sense[i]=1;collission[i]=0;}
        ggl_sprite_set_speed(sprite[i],sense[i]*SPEED,0);
	for (j=i+1;j<NUM_SPRITES;j++) if (i!=j)
	    if (ggl_sprite_collision(sprite[i],sprite[j],NULL) && !collission[i] && !collission[j])
	    {
		sense[i]=-sense[i];
		sense[j]=-sense[j];
		collission[i]=1;
		collission[j]=1;
	    }
    }
}

void load_back()
{
    GglVisual *body=NULL;
    GglFrame *frame;
    GglAnim *anim;
    char *fname="back.png";
    char *palette;
    int palette_size;
    int tx,ty;

    get_png_info(fname,&tx,&ty,&palette,&palette_size);
    body=ggl_visual_new_target("memory");
    ggl_visual_set_mode(body,tx,ty,tx,ty,GGL_8BIT,1);

    ggl_visual_set_palette(body,ggl_palette_new_from_array(0,palette_size,palette));
    get_png_data(fname,ggl_visual_get_write_pointer(body));
    ggl_visual_change_depth(body,DEPTH);
    frame=ggl_frame_new(body);
    anim=ggl_anim_new();
    ggl_anim_append(anim,frame);
    background=ggl_sprite_new();
    ggl_sprite_append(background,anim);
}


void clone_sprite()
{
    int i;
    for (i=1;i<NUM_SPRITES;i++)
    {
	sprite[i]=ggl_sprite_clone(sprite[0]);
    }
}


void move_sprites()
{
    int i;
    for (i=0;i<NUM_SPRITES;i++)
    {
	ggl_sprite_move(sprite[i],228*i,20);
    }
}

void install_sprites()
{
    int i;
    GglLayer *bg_layer=ggl_screen_get_layer_nth(screen,0);
    GglLayer *fg_layer=ggl_layer_new();
    for (i=0;i<NUM_SPRITES;i++)
    {
        ggl_layer_add(fg_layer, GGL_GRAPHIC(sprite[i]));
    }
    ggl_layer_add(bg_layer,GGL_GRAPHIC(background));
    ggl_screen_add_layer(screen,fg_layer);
}

void init_arrays()
{
    int i;
    sprite=(GglSprite**)malloc(sizeof(GglSprite*)*NUM_SPRITES);
    sense=(int*)malloc(sizeof(int)*NUM_SPRITES);
    collission=(char*)malloc(sizeof(char)*NUM_SPRITES);
    for (i=0;i<NUM_SPRITES;i++) sense[i]=(i&1)*2-1; // +1,-1,+1,-1,...
    for (i=0;i<NUM_SPRITES;i++) collission[i]=0;
}

void update_button_sprite2(GglObserver *observer, GglDeviceType type,int device_number,int button,int value)
{
    printf("%s el boton %i del raton\n",value?"Pulsado":"Soltado",button);
}

void update_axis_sprite2(GglObserver *observer, GglDeviceType type,int device_number,int axis,int value)
{
    switch (axis)
    {
    case 0:
	printf("La coordenada x del raton pasa a valer %i\n",value);
	break;
    case 1:
	printf("La coordenada y del raton pasa a valer %i\n",value);
	break;
    default:
	printf("Otra coordenada del raton pasa a valer %i\n",value);
	break;
    }
}

void update_axis_sprite1(GglObserver *observer, GglDeviceType type,int device_number,int axis,int value)
{
    printf("La palanca %i del joystick pasa a valer %i\n",axis,value);
}

int main(int argc, char *argv[])
{

    GglTimeout *screen_timeout=NULL;
    GglCallback cb;
    signal(SIGINT,nohang); //It must be removed it's only for temporary debugging
    
    ggl_init();
    init_arrays();

    load_sprite(); // It loads sprite #0
    clone_sprite(); // Now we clone NUM_SPRITE-1 times the sprite
    load_back();

    /* Moving the sprites to another position */
    move_sprites();

    /*  640x480 screen with DEPTH color bits */
    screen=ggl_screen_new(640,480,640,480,DEPTH,NULL);
    keyboard=ggl_keydev_new(ggl_screen_get_phys_visual(screen));
    mouse=ggl_mousedev_new(ggl_screen_get_phys_visual(screen));
    joystick=ggl_joydev_new(ggl_screen_get_phys_visual(screen));
    ggl_device_attach(GGL_DEVICE(keyboard),GGL_OBSERVER(sprite[0]));
    ggl_device_attach(GGL_DEVICE(joystick),GGL_OBSERVER(sprite[0]));
    ggl_device_attach(GGL_DEVICE(mouse),GGL_OBSERVER(sprite[1]));
    ggl_screen_show(screen,FPS);

    screen_timeout=ggl_screen_get_timeout(screen);
    ggl_device_install(GGL_DEVICE(keyboard),screen_timeout);
    ggl_device_install(GGL_DEVICE(mouse),screen_timeout);
    ggl_device_install(GGL_DEVICE(joystick),screen_timeout);

    // Teclado
    GGL_OBSERVER(sprite[0])->update_button=update_button_sprite1;

    // Joystick
    GGL_OBSERVER(sprite[0])->update_axis=update_axis_sprite1;

    // Raton
    GGL_OBSERVER(sprite[1])->update_button=update_button_sprite2;
    GGL_OBSERVER(sprite[1])->update_axis=update_axis_sprite2;

    /* Installing sprite control function */
    cb.callback=(GglFunc)sprite_control;
    cb.data=NULL;
    ggl_timeout_add_callback(screen_timeout,cb);

    /* Installing objects */
    install_sprites();
//    ggl_background_install(background,screen);

    /* Showing the screen we start the ggl engine */
    ggl_main();

    return 0;
}
