/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLBASE_H__
#define __GGLBASE_H__

#ifdef GGL_DEBUG
 #define GGL_CAST(object, type, typeE) \
 ((type)ggl_cast(((type)object),(((type)object )->id),(typeE),sizeof(type)))
#else /* !GGL_DEBUG */
 #define GGL_CAST(object, type, typeE) ( (type)object )
#endif /* GGL_DEBUG */

#define GGL_BASE(base) ( GGL_CAST(base,GglBase*,GGLBASE) )

#ifndef MAX
#define MAX(a,b) (a)>(b)?(a):(b)
#endif
#ifndef MIN
#define MIN(a,b) (a)<(b)?(a):(b)
#endif


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <ggl/ggltypes.h>

typedef struct _GglBase GglBase;

struct _GglBase{
  int class_size; /* Each object MUST write here his size */
  int id;	  /* Object identifier */
};


void 	*ggl_cast		(void *obj,int i, int j, int size);
void 	ggl_do_nothing		();
void 	ggl_base_set_size	(GglBase *base, int size);

#ifdef __cplusplus
      }
#endif /* __cplusplus */

#endif /*__GGLBASE_H__*/
