/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLDESCRIPTOR_H__
#define __GGLDESCRIPTOR_H__

#include <ggi/ggi.h>
#include <ggl/gglbase.h>
#include <glib.h>

#define GGL_DESCRIPTOR(descriptor) (GGL_CAST(descriptor,GglDescriptor*,GGLDESCRIPTOR))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _GglDescriptor GglDescriptor;

struct _GglDescriptor{
  GglBase base;         /* Base class */
  int id;               /* Class Identifier */
  GList  *node ;  	/* GList node*/
};

/* Constructors */
void		ggl_descriptor_init	(GglDescriptor *descriptor,
					 GList *node);

GglDescriptor*	ggl_descriptor_new	(GList *node);

void		ggl_descriptor_dispose	(GglDescriptor *descriptor);

void		ggl_descriptor_finalize	(GglDescriptor *descriptor);

GglDescriptor*	ggl_descriptor_next	(GglDescriptor *descriptor);

GglDescriptor*	ggl_descriptor_prev	(GglDescriptor *descriptor);


/* Inc & Dec return -1 when the descriptor can't be incremented */
int		ggl_descriptor_inc	(GglDescriptor *descriptor);

int		ggl_descriptor_dec	(GglDescriptor *descriptor);

void*		ggl_descriptor_data	(GglDescriptor *descriptor);

GglDescriptor*	ggl_descriptor_clone	(GglDescriptor *descriptor);
					 
#ifdef __cplusplus
      }
#endif /* __cplusplus */

#endif /* __GGLDESCRIPTOR_H__ */
