/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLNETEVENT_H__
#define __GGLNETEVENT_H__

#include <ggl/gglbase.h>

#define GGL_NETEVENT(net_event) (GGL_CAST(net_event,GglNetEvent*,GGLNETEVENT))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _GglNetEvent GglNetEvent;

struct _GglNetEvent{
  GglBase base;         /* Base class */
  int id;               /* Class Identifier */

  int obj_id;		/* Object identifier */
  void *method;		/* NetEvent handler */
};

/* Constructors */
GglNetEvent *	ggl_net_event_new	(int	obj_id);
void		ggl_net_event_init	(GglNetEvent *	net_event);
void 		ggl_net_event_flush	(void);
void 		ggl_net_event_kill	(void);					 void *	method);
void		ggl_net_event_finalize	(GglNetEvent *	net_event);
void		ggl_net_event_dispose	(GglNetEvent *	net_event);

/* Private functions */
					
#ifdef __cplusplus
      }
#endif /* __cplusplus */

#endif /* __GGLNETEVENT_H__ */


