/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLPALETTE_H__
#define __GGLPALETTE_H__

#include <ggi/ggi.h>
#include <ggl/gglbase.h>

#define GGL_PALETTE(palette) (GGL_CAST(palette,GglPalette*,GGLPALETTE))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _GglPalette GglPalette;

struct _GglPalette{
  GglBase base;         /* Base class */
  int id;               /* Class Identifier */
  ggi_color *palette ;  /* GGI Palette*/
  int first,number;     /* Palette first color defined, and number of colors defined*/
};

/* Constructors */
void		ggl_palette_init	(GglPalette *palette,
					 int first,
					 int number);

GglPalette*	ggl_palette_new         (int first,
					 int number);

void		ggl_palette_dispose	(GglPalette *palette);
					 
void		ggl_palette_finalize	(GglPalette *palette);
					 
GglPalette*	ggl_palette_new_from_array (int first, 
					 int number, 
					 char* palette_array);
					 
void		ggl_palette_set_color	(GglPalette *palette,
					 int index,
					 int r,/* all components of 16 bits */
					 int g,
					 int b,
					 int alpha); 

#ifdef __cplusplus
      }
#endif /* __cplusplus */

#endif /* __GGLPALETTE_H__ */
