/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLTIMEOUT_H__
#define __GGLTIMEOUT_H__

#include <glib.h>
#include <ggl/gglbase.h>

#define GGL_TIMEOUT(timeout) (GGL_CAST(timeout,GglTimeout*,GGLTIMEOUT))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _GglTimeout GglTimeout;

struct _GglTimeout{
  GglBase base;         /* Base class */
  int id;               /* Class Identifier */
  int usec;		/* Microseconds between calls */
  GList *callbacks;	/* Callbacks to be called on each timeout */
  int ticks;		/* Number of *real* ticks between each timeout */
  int curtick;		/* Number of ticks that has passed */
  int active;		/* Indicates if the timeout is active or not */
};

/* Constructors */
void		ggl_timeout_init	(GglTimeout *timeout,
					 int sec,
					 int usec);

GglTimeout*	ggl_timeout_new         (int sec,
					 int usec);

void		ggl_timeout_dispose	(GglTimeout *timeout);
					 
void		ggl_timeout_finalize	(GglTimeout *timeout);

void 		ggl_timeout_add_callback(GglTimeout *timeout,
					 GglCallback callback);

void 		ggl_timeout_start	(GglTimeout *timeout);

#ifdef __cplusplus
      }
#endif /* __cplusplus */

#endif /* __GGLTIMEOUT_H__ */
