/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <ggl/gglobserver.h>
#include <stdlib.h>
void ggl_observer_init(GglObserver *observer)
{
    observer-> update_axis=(void*)ggl_do_nothing;
    observer-> update_button=(void*)ggl_do_nothing;
    observer-> update_collision=(void*)ggl_do_nothing;
    observer-> update_finish=(void*)ggl_do_nothing;
}

GglObserver *ggl_observer_new()
{
    GglObserver *observer=(GglObserver *)malloc(sizeof(GglObserver));
    ggl_base_set_size(GGL_BASE(observer),sizeof(GglObserver));
    
    ggl_observer_init(observer);
    
    return observer;
   
}

void ggl_observer_finalize(GglObserver *observer)
{
}

void ggl_observer_dispose(GglObserver *observer)
{
    ggl_observer_finalize(observer);
    free(observer);
}

void		ggl_observer_update_axis	(GglObserver *observer,
						 GglDeviceType type,
						 int device_number,
						 int axis,
						 int value)
{
    observer->update_axis(observer,type,device_number,axis,value);
}

void		ggl_observer_update_button	(GglObserver *observer,
						 GglDeviceType type,
						 int device_number,
						 int button,
						 int value)
{
    observer->update_button(observer,type,device_number,button,value);
}

/* This method may change, be careful */
void		ggl_observer_update_collision	(GglObserver *observer,
						 GglDeviceType type,
						 void* first,
						 void* second,
						 float angle)
{
    observer->update_collision(observer,type,first,second,angle);
}

void		ggl_observer_update_finish	(GglObserver *observer,
						 GglDeviceType type,
						 int device_number,
						 int action)
{
    observer->update_finish(observer,type,device_number,action);
}
