/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <ggl/ggldescriptor.h>
#include <glib.h>
#include <stdlib.h>

void ggl_descriptor_init(GglDescriptor *descriptor, GList *node)
{
    descriptor-> node=node;
}

GglDescriptor* ggl_descriptor_new(GList *node)
{
    GglDescriptor *descriptor=(GglDescriptor *)malloc(sizeof(GglDescriptor));
    ggl_base_set_size(GGL_BASE(descriptor),sizeof(GglDescriptor));

    ggl_descriptor_init(descriptor,node);

    return descriptor;
}

void ggl_descriptor_finalize(GglDescriptor* descriptor)
{
}

void ggl_descriptor_dispose(GglDescriptor* descriptor)
{
  free(descriptor);
}


GglDescriptor*	ggl_descriptor_next (GglDescriptor *descriptor)
{
    return ggl_descriptor_new(descriptor->node->next);
}

GglDescriptor*	ggl_descriptor_prev (GglDescriptor *descriptor)
{
    return ggl_descriptor_new(descriptor->node->prev);
}

int ggl_descriptor_inc(GglDescriptor *descriptor)
{
  descriptor->node=descriptor->node->next;
  return (descriptor->node!=NULL)-1;
}

int ggl_descriptor_dec(GglDescriptor *descriptor)
{
  descriptor->node=descriptor->node->prev;
  return (descriptor->node!=NULL)-1;
}

void* ggl_descriptor_data (GglDescriptor *descriptor)
{
    return descriptor->node->data;
}

GglDescriptor *ggl_descriptor_clone (GglDescriptor *descriptor)
{
  return ggl_descriptor_new(descriptor->node);
}
