/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <ggl/gglrectangle.h>
#include <stdio.h>

void ggl_rectangle_display(GglRectangle r)
{
  printf("x=%i, y=%i, width=%i, height=%i\n",r.x,r.y,r.width,r.height);
}

int ggl_rectangle_overlap(GglRectangle r1, GglRectangle r2)
{
    int x1l,y1u,x1r,y1d; // bounds of the first rectangle
    int x2l,y2u,x2r,y2d; // bounds of the second rectangle
    x1l=r1.x;
    x1r=x1l+r1.width;
    y1u=r1.y;
    y1d=y1u+r1.height;

    x2l=r2.x;
    x2r=x2l+r2.width;
    y2u=r2.y;
    y2d=y2u+r2.height;
    
    if (x2l > x1r || y2u > y1d || x2r < x1l || y2d < y1u) return 0;
    return 1;
}