 Sintaxis de la herramienta GGLDOC:
------------------------------------

Se basa en 9 simples etiquetas:

* %module : Declarar un mdulo.
* %class  : Declarar una clase. 
* %method : Declarar un mtodo.
* %format : Indicar el formato de un mtodo.
* %father : Indicar la clase padre de la que estamos declarando.
* %arglist: Indica que el mtodo tiene argumentos.
* %arg    : Declara un argumento.
* %return : Explica el argumento de retorno.
* %=      : Sirve para describir un elemento.

	Como veris, todas ellas empiezan por el smbolo '%'. Cada una es
para una cosa especfica, esto hace que se produzcan menos los.
	La forma de combinar esas etiquetas para producir una documentacin
vlida para GGLDOC es la siguiente:

* MODULOS:

%module <nombre_modulo> %= <descripcin_modulo>

{<clases>}

* CLASES:

%class <nombre_clase> %= <descripcin_clase>
%father <nombre_clase_padre>

{<mtodos>}

* MTODOS:

%method <nombre_mtodo %= <descripcin_mtodo>
%format <formato>
[ %arglist {<argumentos>} ]
[ %return <descripcin_valor_retorno> ]

* ARGUMENTOS

%arg <argumento> %= <descripcin_argumento>


------------
PREPROCESADOR:

	Es posible incluir la sentencia #include, exactamente igual que lo
haramos en C, para poder estructurar mejor la documentacin. Al menos, cada
clase debe ir en su propio fichero. No lo obliga el programa GGLDOC, pero es
como se est haciendo hasta ahora en el proyecto.
------------
SINTAXIS VISTA DE OTRA FORMA:

%module <modulo> %= <descripcin>

   %class <clase> %= <descripcin>
      %father <clase_padre>
      %method <metodo> %= <descripcin>
         %format <formato>
         %arglist
            %arg <argumento> %= <descripcin>
	    %arg <argumento> %= <descripcion>
            [...]
         %return <descripcin>

      %method <metodo %= <descripcion>
         %format <formato>


   %class <clase> %= <descripcin>
   [...]


%module <modulo> %= <descripcion>
[...]


AHORA VEAMOS UN EJEMPLO:

*************[fichero graphics.ggld]*************************************
************************************************************************

%module Graphics %= This chapter contains all the classes of the graphic
		    system (2D and 3D).
	#include "gglvisual.gglh"
	#include "gglscreen.gglh"
	#include "gglsprite.gglh"
	#include "gglanim.gglh"
	#include "gglbackground.gglh"
	#include "gglcolor.gglh"
	#include "gglframe.gglh"
	#include "gglmask.gglh"
	#include "gglpalette.gglh"

*************[fichero gglpalette.gglh]**********************************
************************************************************************

%class GglPalette %= Encapsulates a palette, or a piece of palette.
   %father GglBase
	%method ggl_palette_new %= Class constructor. The contents of the
				   palette are unknown.
		%format GglPalette* ggl_palette_new (int first,int number);
		%arglist
			%arg first %= Must be 0 unless you only want to
				      create a piece of a palette. If that, 
				      then it must be the first color of the
				      piece.
			%arg number %= Must be 256 unless you only want to
				       create a piece of a palette. If that, it
				       must be the number of colors of the
				       piece.
		%return The new object.
                
	%method ggl_palette_new_from_array %= Class constructor. Creates a
		palette or a piece of palette from a initialized array.
		The array must be in this way:
		<p><tt>[R1 G1 B1 R2 G2 B2 R3 G2 B3 ...]</tt>
		<p>And must have values between 0 and 255 for each component.
		%format GglPalette* ggl_palette_new_from_array (int first,int number,char* palette_array);
		%arglist
			%arg first %= Must be 0 unless you only want to
				create a piece of a palette. If that, then it 
				must be the first color of the piece.
			%arg number %= Must be 256 unless you only want to
				create a piece of a palette. If that, it must 
				be the number of colors of the piece.
			%arg palette_array %= The byte array.

	%method ggl_palette_set_color %= Changes a color of the palette.
		This color must be between the first and first+number values 
		of the palette (in the case that this object only contains a 
		piece of palette)
			All the components must be 16bit values. Then, they
		must be between 0 and 65535. Scale your values if needed with 
		"<<".
		%format void ggl_palette_set_color (GglPalette *palette,
					int index,int r,int g,int b,int alpha);
		%arglist
			%arg index %= Color of the palette that must be
				changed.
			%arg r,g,b %= red, green, blue values.
			%arg alpha %= It's a fourth component for the user,
				do what tou prefer with it.

***************************************************************+

Fin del documento. Me voy a ver los simpson.
Autor: <ryu@mundivia.es>
Generador: joe
